import * as React from "react";
import { CB, IChannel, ISchedulerProps, Q } from "./Types";
export declare class Scheduler extends React.Component<ISchedulerProps, {
    recalculate: number;
    queue: Q[];
}> {
    private queue;
    private timeout;
    private sortOnQ;
    state: {
        recalculate: number;
        queue: Q[];
    };
    componentWillUnmount(): void;
    componentDidUpdate(props: ISchedulerProps): void;
    update(): void;
    scheduleQ(when: number): void;
    add: (cb: CB, priority: number, ref: any) => {
        cb: CB;
        priority: number;
        index: number;
        sortOrder: number;
        ref: any;
        executed: boolean;
    };
    remove: (q: any) => void;
    replace: (q: any, cb: CB, priority: number, ref: any) => any;
    reset: () => void;
    channel: IChannel;
    sortQ(): void;
    nextQ(): Q;
    executeQ(): void;
    noExecutedTask(): boolean;
    render(): React.ReactNode;
}
