import * as React from 'react';
export interface ICatchState {
    caught: number;
    pending: boolean[];
    resolved: any[];
    rejected: boolean[];
}
export interface IChildrenProps {
    caught: number;
    pending: boolean;
    rejected: boolean;
    resolved: boolean;
    results: any[];
}
export interface ICatchProps {
    catch: (e: Promise<any>) => boolean;
    children: (state: IChildrenProps) => React.ReactNode;
}
export declare class Catcher extends React.Component<ICatchProps, ICatchState> {
    state: {
        caught: number;
        pending: any;
        resolved: any;
        rejected: any;
    };
    componentDidCatch(error: Error | Promise<any>): void;
    render(): React.ReactNode;
}
