"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Queue = (function (_super) {
    __extends(Queue, _super);
    function Queue() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.setRef = function (ref) { return _this.ref = ref; };
        return _this;
    }
    Queue.prototype.componentDidMount = function () {
        var _a = this.props, channel = _a.channel, callback = _a.callback, priority = _a.priority, disabled = _a.disabled;
        this.q = channel.add(callback, disabled ? Infinity : (priority || 0), this.ref);
    };
    Queue.prototype.componentWillUnmount = function () {
        var channel = this.props.channel;
        channel.remove(this.q);
    };
    Queue.prototype.componentDidUpdate = function () {
        var _a = this.props, channel = _a.channel, callback = _a.callback, priority = _a.priority, disabled = _a.disabled;
        channel.replace(this.q, callback, disabled ? Infinity : (priority || 0), this.ref);
    };
    Queue.prototype.render = function () {
        return this.props.children
            ? React.cloneElement(React.Children.only(this.props.children), { ref: this.setRef })
            : null;
    };
    return Queue;
}(React.Component));
exports.Queue = Queue;
