"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Trigger = (function (_super) {
    __extends(Trigger, _super);
    function Trigger() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Trigger.prototype.componentDidMount = function () {
        this.componentDidUpdate();
    };
    Trigger.prototype.componentDidUpdate = function () {
        this.props.when && this.props.then();
    };
    Trigger.prototype.componentWillMount = function () {
        this.props.finally && this.props.finally();
    };
    Trigger.prototype.shouldComponentUpdate = function (props) {
        return this.props.when !== props.when;
    };
    Trigger.prototype.render = function () {
        return null;
    };
    return Trigger;
}(React.Component));
exports.Trigger = Trigger;
